////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <largeString.h>

#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!
#include <string>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "p\002\000\000q\002\000\000r\002\000\000s\002\000\000\345\002\000\000\362\002\000\000\367"
  "\002\000\000>\003\000\000Y\003\000\000`\003\000\000c\003\000\000e\003\000\000$\004\000\000,\004\000\0002\004\000\000o"
  "\004\000\000\225\004\000\000\236\006\000\000'\007\000\000\235\007\000\000\014\010\000\000#\010\000\000\303\010\000"
  "\000\310\n\000\000\314\n\000\000\277\013\000\000\302\013\000\000\014\014\000\000\017\014\000\000/\014\000\000|\014"
  "\000\000\356\014\000\000\007\015\000\0004\015\000\000+\017\000\0008\017\000\000D\017\000\000W\017\000\000\273\017\000"
  "\000\274\017\000\000\276\017\000\000\277\017\000\000\301\017\000\000\302\017\000\000\376\017\000\000\021\020\000\000"
  "\027\020\000\000\030\020\000\000\311\020\000\000\025\021\000\000F\021\000\000u\021\000\000\317\021\000\000\366\021"
  "\000\000\017\022\000\000\020\022\000\000\021\022\000\000\023\022\000\000u\022\000\000\230\022\000\000\355\022\000\000"
  "\036\023\000\000l\023\000\000\312\023\000\000\360\023\000\000[\024\000\000v\024\000\000\262\024\000\000\332\024\000"
  "\000\347\024\000\000'\025\000\000b\025\000\000\203\025\000\000\244\025\000\000\274\025\000\000\360\025\000\000\362"
  "\025\000\000\366\025\000\000\020\026\000\0005\026\000\000;\026\000\000=\026\000\000A\026\000\000Y\026\000\000\273\026"
  "\000\000\031\027\000\000w\027\000\000\313\027\000\000\015\030\000\000k\030\000\000y\030\000\000\261\030\000\000\262"
  "\030\000\000\263\030\000\000\314\030\000\000\377\030\000\000\005\031\000\000\007\031\000\000\t\031\000\000S\031\000"
  "\000Y\031\000\000[\031\000\000]\031\000\000\255\031\000\000\263\031\000\000\265\031\000\000\267\031\000\000\274\031"
  "\000\000\003\032\000\000\t\032\000\000\013\032\000\000\014\032\000\000\021\032\000\000E\032\000\000t\032\000\000\244"
  "\032\000\000\250\032\000\000\264\032\000\000\274\032\000\000\367\032\000\000\000\033\000\000%\033\000\000.\033\000"
  "\0001\033\000\0008\033\000\0009\033\000\000:\033\000\000H\033\000\000I\033\000\000J\033\000\000i\033\000\000k\033\000"
  "\000v\033\000\000\205\033\000\000\206\033\000\000\207\033\000\000\252\033\000\000\266\033\000\000\277\033\000\000\306"
  "\033\000\000\307\033\000\000\310\033\000\000\311\033\000\000\312\033\000\000\313\033\000\000\314\033\000\000\315\033"
  "\000\000\316\033\000\000\317\033\000\000\331\033\000\000\350\033\000\000\354\033\000\000\355\033\000\000\356\033\000"
  "\000\357\033\000\000\360\033\000\000\n\n\n\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-widt"
  "h, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n\n<script type=\"text/javascript\" src=\"js/live"
  "/createHtml.js\"></script>\n\n<script>\nconst recs = [];\n  recs[]=[]\nconst rec_ids = Object.create(null)\nrec_ids["
  "\"T\"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 're"
  "cording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=\" title=\"'\n  s.a += Title\n  s.a += '\"><img class=\"icon\" "
  "src=\"'\n  s.a += Img\n  s.a += '\" /></a>'\n}\n\n\nfunction RecordingsSt(s, level, displayFolder, data) {\n  s.a += "
  "'<li class=\"recording\"><div>'\n  s.a += '<table width=\"100%\" class=\"recordings\">'\n  for (obj_i of data) {\n   "
  " obj = recs[obj_i]\n    s.a += '<tr class=\"recording_item\">'\n    if (level > 0) s.a += \n      '<td class=\"space"
  "\"> <img src=\"img/transparent.png\" width=\"' + String(16 * level) + 'px\" height=\"16px\" /></td>'\n    s.a += '<td"
  " class=\"td-hidden-xs\"><div class=\"hidden-xs recording_imgs\">'\n    if (obj[1].length != 0) {\n      s.a += '<img "
  "class=\"icon\" src=\"on_dvd.png\" alt=\"on_dvd\" title=\"'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n   "
  "   s.a += '<input type=\"checkbox\" name=\"deletions\" value=\"recording_'\n      s.a += obj[0]\n      s.a += '\" />'"
  "\n    }\n    s.a += '</div></td>'  // end of recording_imgs\n    s.a += '<td class=\"space\">'\n      addScraperImage"
  "Title(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '');\n    s.a += '</td>'\n    s.a += '<td class=\"td-hidden-"
  "xs\"><div class=\"hidden-xs recording_day\">'\n    s.a += obj[9]\n    if (obj[17] > 0) {\n      s.a += '<span title="
  "\"'\n      s.a += ''\n      s.a += '\"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a += '</span>'\n    "
  "}\n    s.a += '</div></td><td>'\n    addErrorIcon(s, obj[10], obj[17])\n    addHdSdIcon(s, obj[11], obj[12])\n    s.a"
  " += '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class=\"recording_name'\n    s.a += obj[13]"
  "\n    s.a += '\">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class=\"with"
  "margin\">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], '', '')\n    s.a += '</div></"
  "div></td>'  // end if recording_name / short description\n    s.a += '<td><div class=\"recording_actions\">'\n    if "
  "(obj[1].length == 0) {\n      RecordingActionS(s, obj[0], \"vdr_request/play_recording\?param=\", \"play.png\", \"\")"
  "\n      RecordingActionS(s, obj[0], \"playlist.m3u\?recid=\", \"playlist.png\", \"\")\n      IMDBS(s, obj[2], obj[14]"
  ")\n      RecordingActionS(s, obj[0], \"edit_recording.html\?recid=\", \"edit.png\", \"\")\n      s.a += '<div class="
  "\"hidden-ts\">'\n      RecordingActionS(s, obj[0], \"recordings.html\?todel=\", \"del.png\", \"\")\n      s.a += '</d"
  "iv>'\n    } else {\n      IMDBS(s, obj[2], obj[14])\n    }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n     "
  " s.a += '<div class=\"recording_arch\">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'"
  "\n  }\n  s.a += '</table></div></li>'\n}\n\nfunction rec_string_d(rec_ids) {\n// use img data-src= ...\n  const st = "
  "Object.create(null)\n  st.a = \"\"\n  RecordingsSt(st, rec_ids[0], rec_ids[1], rec_ids[2])\n  return st.a\n}\n\n</scr"
  "ipt>\n\n  <script type=\"text/javascript\" src=\"js/live/treeview.js\"></script>\n  <script>\n  const tv = new Treevi"
  "ew(\"minus.png\", \"plus.png\", \"folder_open.png\", \"folder_closed.png\");\n  </script>\n</head>\n<body onload=\"ad"
  "justHeader()\" onresize=\"adjustHeader()\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div class=\"boxheader\"><div>"
  "<div></div></div></div>\n      \n      <form method=\"post\" name=\"recordings\" action=\"recordings.ecpp\">\n       "
  " <div class=\"recordings\">\n          <ul class=\"recordingslist\" style=\"display: block;\">\n            \n       "
  "   </ul>\n        </div>\n\t\t\t\t<input type=\"hidden\" name=\"sort\" value=\"\">\n\t\t\t\t<input type=\"hidden\" na"
  "me=\"filter\" value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"flat\" value=\"\">\n        <div class=\"withmargin "
  "hidden-xs\">\n          <button class=\"red\" type=\"submit\"></button>\n        </div>\n      </form>\n  </div>\n</b"
  "ody>\n</html>\n\n\n\n\n      <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle(th"
  "is, 'fldr_')\">\n        <table><tr>\n                      <td class = \"space\">\n              <img src=\"img/tran"
  "sparent.png\" width=\"px\" height=\"16px\" />\n            </td>\n                    <td class=\"space\">\n         "
  "   <img class=\"recording_expander\" src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class"
  "=\"recording_folder\" src=\"folder_closed.png\" />\n          </td>\n            <td class = space>\n              <d"
  "iv class=\"thumb\">\n                <img data-src=\"/tvscraper/\"\n                  class=\"\"\n                />"
  "\n              </div>\n            </td>\n        <td class=\"recording_folder_name\">\n          \n        </td></t"
  "r></table>\n        </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          \n"
  "        </ul>\n      </li>\n          <script>\n      rec_ids[\"fldr_\"] = []\n    </script>\n        <script>\n     "
  "   document.write(rec_string_d([, , [  ]]))\n      </script>\n          <script>\n        rec_ids[\"fldr_\"] = [, , ["
  "  ]]\n      </script>\n          <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggl"
  "e(this, 'fldr_')\">\n          <table><tr><td class=\"space\">\n            <img class=\"recording_expander\" src=\"p"
  "lus.png\" />\n          </td><td class=\"space\">\n            <img class=\"recording_folder\" src=\"folder_closed.pn"
  "g\" />\n          </td><td class=\"recording_folder_name\">\n            \n          </td></tr></table>\n        </di"
  "v>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          <script>\n            rec_"
  "ids[\"fldr_\"] = [1, 1, [  ]]\n          </script>\n        </ul>\n      </li>\n      \n\n<span class=\"label bold\">"
  " </span>\n<a href=\"recordings.html\?sort=name&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"record"
  "ings.html\?sort=date&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=duplicates"
  "&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=errors&filter=&flat=\" ></a>\n"
  "<span class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\""
  "filter\" onchange=\"filterRecordings(this, '', '')\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img onclick=\"Ex"
  "pandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\nclass=\"active\"\n"
  "\n<a href=\"recordings.html\?todel=\" ><img src=\"\" alt=\"\" /></a>\n\n<a href=\"edit_recording.html\?recid=\"><img "
  "src=\"\" alt=\"\"  /></a>\n\n\n\n\n\n\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 43 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

// create the "current" values of the global request parameters, based on their old values and the current arguments
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
//  if (currentSort.compare(0, 6, "errors", 6) == 0 && currentFlat != "true") currentSort = "dateasc";
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}
for (auto it = deletions.begin(); it != deletions.end(); ++it) {
  if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
    RemoveRecordingTask task(*it);
    LiveTaskManager().Execute(task);
    if (!task.Result())
      deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
    else
      deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
  }
  else {
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  }
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));
#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif
const char *lf;
if (LiveSetup().GetUseAjax()) lf = "<br/>";
else lf = "&#13;";



  // <& pageelems.doc_type ...
  { 
#line 109 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 109 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 113 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 114 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 114 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 115 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 115 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\n<script type="text/javascript" src="js/live/createHtml.js"></script>\n
  // <& pageelems.create_html_js ...
  { 
#line 118 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 118 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recs = [];\n
#line 121 "recordings.ecpp"

cLargeString recoring_item("recoring_item", 25000);
char buffer_i[20];
RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
for (const RecordingsItemPtr &rPtr: *recordingsTree->allRecordings()) {
  recoring_item.clear();
  rPtr->AppendAsJSArray(recoring_item, currentFlat == "true" || currentSort == "duplicates");

  reply.out() << _tntChunks[8]; //   recs[
#line 129 "recordings.ecpp"
  reply.sout() << (intToChar(buffer_i, buffer_i+20, rPtr->IdI()));
  reply.out() << _tntChunks[9]; // ]=[
#line 129 "recordings.ecpp"
  reply.out() << ( recoring_item.c_str() );
  reply.out() << _tntChunks[10]; // ]\n
#line 130 "recordings.ecpp"

}

  reply.out() << _tntChunks[11]; // const rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 141 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[12]; // &filter=
#line 141 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[13]; // &flat=
#line 141 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[14]; // " title="'\n  s.a += Title\n  s.a += '"><img class="icon" src="
#line 143 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[15]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\n\n
  reply.out() << _tntChunks[16]; // \nfunction RecordingsSt(s, level, displayFolder, data) {\n  s.a += '<li class="recording"><div>'\n  s.a += '<table width="100%" class="recordings">'\n  for (obj_i of data) {\n    obj = recs[obj_i]\n    s.a += '<tr class="recording_item">'\n    if (level > 0) s.a += \n      '<td class="space"> <img src="img/transparent.png" width="' + String(16 * level) + 'px" height="16px" /></td>'\n    s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_imgs">'\n    if (obj[1].length != 0) {\n      s.a += '<img class="icon" src="
#line 181 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[17]; // on_dvd.png" alt="on_dvd" title="'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n      s.a += '<input type="checkbox" name="deletions
#line 185 "recordings.ecpp"
  reply.sout() << (TNT_ARRAY);
  reply.out() << _tntChunks[18]; // " value="recording_'\n      s.a += obj[0]\n      s.a += '" />'\n    }\n    s.a += '</div></td>'  // end of recording_imgs\n
#line 190 "recordings.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[19]; //     s.a += '<td class="space">'\n      addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 192 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[20]; // ');\n    s.a += '</td>'\n
#line 194 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[21]; //     s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_day">'\n    s.a += obj[9]\n    if (obj[17] > 0) {\n      s.a += '<span title="'\n      s.a += '
#line 199 "recordings.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[22]; // '\n      s.a += '"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a += '</span>'\n    }\n    s.a += '</div></td><td>'\n    addErrorIcon(s, obj[10], obj[17])\n    addHdSdIcon(s, obj[11], obj[12])\n    s.a += '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class="recording_name'\n    s.a += obj[13]\n    s.a += '">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class="withmargin">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], '
#line 215 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[23]; // ', '
#line 215 "recordings.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[24]; // ')\n    s.a += '</div></div></td>'  // end if recording_name / short description\n    s.a += '<td><div class="recording_actions">'\n    if (obj[1].length == 0) {\n      RecordingActionS(s, obj[0], "vdr_request/play_recording\?param=", "play.png", "
#line 219 "recordings.ecpp"
  reply.sout() << (tr("play this recording"));
  reply.out() << _tntChunks[25]; // ")\n
#line 220 "recordings.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[26]; //       RecordingActionS(s, obj[0], "playlist.m3u\?recid=", "playlist.png", "
#line 221 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[27]; // ")\n
#line 222 "recordings.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[28]; //       IMDBS(s, obj[2], obj[14])\n
#line 224 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[29]; //       RecordingActionS(s, obj[0], "edit_recording.html\?recid=", "edit.png", "
#line 225 "recordings.ecpp"
  reply.sout() << (tr("Edit recording"));
  reply.out() << _tntChunks[30]; // ")\n      s.a += '<div class="hidden-ts">'\n      RecordingActionS(s, obj[0], "recordings.html\?todel=", "del.png", "
#line 227 "recordings.ecpp"
  reply.sout() << (tr("Delete this recording from hard disc!"));
  reply.out() << _tntChunks[31]; // ")\n      s.a += '</div>'\n
#line 229 "recordings.ecpp"
 if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[32]; //     } else {\n      IMDBS(s, obj[2], obj[14])\n
#line 232 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[33]; //     }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n      s.a += '<div class="recording_arch">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'\n  }\n  s.a += '</table></div></li>'\n}\n\nfunction rec_string_d(rec_ids) {\n// use img data-src= ...\n  const st = Object.create(null)\n  st.a = ""\n  RecordingsSt(st, rec_ids[0], rec_ids[1], rec_ids[2])\n  return st.a\n}\n\n</script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 257 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[34]; // minus.png", "
#line 257 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[35]; // plus.png", "
#line 257 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[36]; // folder_open.png", "
#line 257 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[37]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()">\n  
  // <& pageelems.logo ...
  { 
#line 261 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 261 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[38]; // \n
#line 262 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[39]; //   
  // <& menu ...
  { 
#line 269 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 269 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 269 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 269 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 269 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[40]; // \n
#line 270 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[41]; //   
  // <& menu ...
  { 
#line 273 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 273 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 273 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 273 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 273 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[42]; // \n
#line 274 "recordings.ecpp"

}

  reply.out() << _tntChunks[43]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 278 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[44]; // </div></div></div>\n
#line 279 "recordings.ecpp"

    int rec_cnt;
#if VDRVERSNUM >= 20301
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
#else
    rec_cnt = Recordings.Count(); // Access VDRs global cRecordings Recordings instance.
#endif
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[45]; //       
#line 291 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[46]; // \n
#line 292 "recordings.ecpp"

    } else {
      uintptr_t irecoring_item = (uintptr_t)&recoring_item;
      RecordingsItemPtr recItemRoot = recordingsTree->getRoot();
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;

  reply.out() << _tntChunks[47]; //       <form method="post" name="recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 301 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 301 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 301 "recordings.ecpp"
    _tnt_cq7.add( "irecoring_item", (irecoring_item));
#line 301 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[48]; // \n          </ul>\n        </div>\n\t\t\t\t<input type="hidden" name="sort" value="
#line 304 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[49]; // ">\n\t\t\t\t<input type="hidden" name="filter" value="
#line 305 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[50]; // ">\n\t\t\t\t<input type="hidden" name="flat" value="
#line 306 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[51]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 308 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[52]; // </button>\n        </div>\n      </form>\n
#line 311 "recordings.ecpp"

    }

  reply.out() << _tntChunks[53]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[54]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[55]; // \n
  reply.out() << _tntChunks[56]; // \n\n
  reply.out() << _tntChunks[91]; // \n
  reply.out() << _tntChunks[92]; // \n
  reply.out() << _tntChunks[124]; // \n
  reply.out() << _tntChunks[125]; // \n
  reply.out() << _tntChunks[127]; // \n
  reply.out() << _tntChunks[128]; // \n
  reply.out() << _tntChunks[133]; // \n
  reply.out() << _tntChunks[134]; // \n
  reply.out() << _tntChunks[139]; // \n
  reply.out() << _tntChunks[140]; // \n
  reply.out() << _tntChunks[146]; // \n
  reply.out() << _tntChunks[147]; // \n
  reply.out() << _tntChunks[152]; // \n
  reply.out() << _tntChunks[153]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecoring_item = qparam.get< uintptr_t >("irecoring_item", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 327 "recordings.ecpp"

// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
bool reverse = false;
eSortOrder sortOrder = eSortOrder::name; // default
if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = eSortOrder::date;
if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = eSortOrder::errors;
if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = eSortOrder::durationDeviation;
if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = eSortOrder::duplicatesLanguage;
if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
// get rec item of this (current) dir
RecordingsItemPtr recItemThisDir = *(static_cast<RecordingsItemPtr *>((void *)iRecItem) );
int level = recItemThisDir->Level();
cLargeString *recoring_item = static_cast<cLargeString *>((void *)irecoring_item );

std::vector<RecordingsItemPtr> recItems;
const std::vector<RecordingsItemPtr> *recItemsC = NULL;

// data for dirs, an loop over dirs
const std::vector<RecordingsItemPtr> *dirItems = recItemThisDir->getDirs();
std::vector<RecordingsItemPtr>::const_iterator dirIterS, dirIterE, dirIter;
int direction; // for dirs
if (currentFlat != "true") {
  if (currentSort != "duplicates") {
// list of subdirs
    if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") {
// reverse loop over subdirs
      dirIterS = dirItems->end();
      dirIterE = dirItems->begin();
      direction = 0;
    } else {
// forward loop over subdirs
      dirIterS = dirItems->begin();
      dirIterE = dirItems->end();
      direction = 1;
    }
    for (dirIter = dirIterS; dirIter != dirIterE; std::advance(dirIter, direction) ) {
      if(direction == 0) dirIter--;
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>
      RecordingsItemPtr recItem = *dirIter;

      /* search trough directory for new recordings */
      bool newR = false;
      if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
      std::string idHash(xxHash32(parentIdHash + recItem->Name()));
      iRecItem = (uintptr_t)&recItem;
  
  reply.out() << _tntChunks[57]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 378 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[58]; // ')">\n        <table><tr>\n          
#line 380 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[59]; //             <td class = "space">\n              <img src="img/transparent.png" width="
#line 382 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[60]; // px" height="16px" />\n            </td>\n          
#line 384 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[61]; //           <td class="space">\n            <img class="recording_expander" src="
#line 386 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[62]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 388 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[63]; // folder_closed.png" />\n          </td>\n
#line 390 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[64]; //             <td class = space>\n              <div class="thumb">\n                <img data-src="/tvscraper/
#line 393 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[65]; // "\n                  class="
#line 394 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[66]; // "\n                />\n              </div>\n            </td>\n
#line 398 "recordings.ecpp"
         }

  reply.out() << _tntChunks[67]; //         <td class="recording_folder_name
#line 399 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[68]; // ">\n          
#line 400 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[69]; // \n        </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 403 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[70]; // " class="recordingslist" style="display: none;">\n          
  // <& recordings.recordings_item ...
  { 
#line 404 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 404 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 404 "recordings.ecpp"
    _tnt_cq8.add( "irecoring_item", (irecoring_item));
#line 404 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 404 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[71]; // \n        </ul>\n      </li>\n      
#line 407 "recordings.ecpp"

    } // end of loop over subdirs
// now the items
    recItemsC = recItemThisDir->getRecordings(sortOrder);
    if (recItemThisDir->recEntriesSorted() ) reverse = false;
  } // end if (currentSort != "duplicates")
} else {
// here we prepare the items in case of a flat list, no folders
  RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
  if (currentSort != "duplicates") { 
    recItemsC = recordingsTree->allRecordings(sortOrder);
  } else {
    recItems.clear();
    addDuplicateRecordingsSd(recItems, recordingsTree);
    addDuplicateRecordingsLang(recItems, recordingsTree);
    addDuplicateRecordingsNoSd(recItems, recordingsTree);
    recItemsC = &recItems;
  }
}
if (currentSort != "duplicates" || currentFlat == "true") {
  if (recItemsC->empty() ) { 
  reply.out() << _tntChunks[72]; //     <script>\n      rec_ids["fldr_
#line 429 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[73]; // "] = []\n    </script>\n  
#line 431 "recordings.ecpp"
 } else {
    bool first = true;
    const char *displayFolder = currentFlat == "true"?"1":"0";
    recoring_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recoring_item, recItemsC->begin(), recItemsC->end(), first, currentFilter, reverse);
    if (level == 0) { 
  reply.out() << _tntChunks[74]; //       <script>\n        document.write(rec_string_d([
#line 438 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[75]; // , 
#line 438 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[76]; // , [ 
#line 438 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[77]; //  ]]))\n      </script>\n    
#line 440 "recordings.ecpp"
 } else { 
  reply.out() << _tntChunks[78]; //       <script>\n        rec_ids["fldr_
#line 442 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[79]; // "] = [
#line 442 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[80]; // , 
#line 442 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[81]; // , [ 
#line 442 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[82]; //  ]]\n      </script>\n    
#line 444 "recordings.ecpp"
 }
  }
} else {
// duplicates
  RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    if (!recItems.empty() ) {
      std::string idHash(xxHash32(nodeName));
      bool first = true;
      recoring_item->clear();
      RecordingsItemRec::AppendAsJSArray(*recoring_item, recItems.begin(), recItems.end(), first, currentFilter, false);
      
  reply.out() << _tntChunks[83]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 469 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[84]; // ')">\n          <table><tr><td class="space">\n            <img class="recording_expander" src="
#line 471 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[85]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 473 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[86]; // folder_closed.png" />\n          </td><td class="recording_folder_name">\n            
#line 475 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[87]; // \n          </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 478 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[88]; // " class="recordingslist" style="display: none;">\n          <script>\n            rec_ids["fldr_
#line 480 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[89]; // "] = [1, 1, [ 
#line 480 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[90]; //  ]]\n          </script>\n        </ul>\n      </li>\n      
#line 484 "recordings.ecpp"

    }
  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 493 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[93]; // <span class="label bold">
#line 494 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[94]; //  </span>\n<a href="recordings.html\?sort=name&filter=
#line 495 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[95]; // &flat=
#line 495 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[96]; // " 
  // <& setactive ...
  { 
#line 495 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 495 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 495 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[97]; //  >
#line 495 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[98]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 497 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[99]; // &flat=
#line 497 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[100]; // " 
  // <& setactive ...
  { 
#line 497 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 497 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 497 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[101]; //  >
#line 497 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[102]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 499 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[103]; // &flat=
#line 499 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[104]; // " 
  // <& setactive ...
  { 
#line 499 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 499 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 499 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[105]; //  >
#line 499 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[106]; // </a>\n
#line 500 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[107]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=errors&filter=
#line 504 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[108]; // &flat=
#line 504 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[109]; // " 
  // <& setactive ...
  { 
#line 504 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 504 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 504 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[110]; // >
#line 504 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[111]; // </a>\n
#line 505 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[112]; // <span class="sep">|</span>\n<span class="label bold">
#line 510 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[113]; // :&nbsp;<input type="text" name="filter" value="
#line 510 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[114]; // " id="filter" onchange="filterRecordings(this, '
#line 510 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[115]; // ', '
#line 510 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[116]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 510 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 510 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 510 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[117]; // </span>\n
#line 511 "recordings.ecpp"

#endif
if (currentFlat != "true") {

  reply.out() << _tntChunks[118]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 516 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[119]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 516 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 516 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 516 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[120]; // />\n<img onclick="CollapseAll()" src="
#line 517 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[121]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 517 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 517 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 517 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[122]; // />\n
#line 518 "recordings.ecpp"

}

  reply.out() << _tntChunks[123]; // <br />\n
#line 522 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 530 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[126]; // class="active"
#line 531 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 539 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[129]; // <a href="recordings.html\?todel=
#line 539 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[130]; // " 
  // <& tooltip.hint ...
  { 
#line 539 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 539 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 539 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[131]; // ><img src="
#line 539 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[132]; // " alt="" /></a>
#line 539 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 547 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[135]; // <a href="edit_recording.html\?recid=
#line 547 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[136]; // "><img src="
#line 547 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[137]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 547 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 547 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 547 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[138]; //  /></a>
#line 547 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 557 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 557 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 557 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 557 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 557 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 557 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording.")));
#line 557 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 558 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 558 "recordings.ecpp"
    _tnt_cq19.add( "recid", (id));
#line 558 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 559 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 559 "recordings.ecpp"
    _tnt_cq20.add( "s_IMDB_ID", (s_IMDB_ID));
#line 559 "recordings.ecpp"
    _tnt_cq20.add( "title", (title));
#line 559 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[143]; // \n
  // <& recordings.edit_rec ...
  { 
#line 560 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 560 "recordings.ecpp"
    _tnt_cq21.add( "id", (id));
#line 560 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n
  // <& recordings.del_rec ...
  { 
#line 561 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 561 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 561 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[145]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[148]; // <img src="
#line 571 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[149]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 571 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 571 "recordings.ecpp"
    _tnt_cq23.add( "text", (archived));
#line 571 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[150]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 572 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 572 "recordings.ecpp"
    _tnt_cq24.add( "s_IMDB_ID", (s_IMDB_ID));
#line 572 "recordings.ecpp"
    _tnt_cq24.add( "title", (title));
#line 572 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[151]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 577 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 577 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[154]; // \n
#line 578 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
