////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"


#include <setup.h>
#include <tools.h>
#include <users.h>
#include <live.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "L\001\000\000\267\001\000\000\302\001\000\000\305\001\000\000\240\005\000\000\243\005\000"
  "\000\032\006\000\000^\006\000\000\033\007\000\000\200\007\000\000\355\007\000\000\314\010\000\000\014\t\000\000\214\t"
  "\000\000\320\t\000\000d\n\000\000\315\n\000\000\025\013\000\000\265\013\000\000$\014\000\000\200\014\000\000\355\014"
  "\000\000\314\015\000\000*\016\000\000\266\016\000\000-\017\000\000\026\020\000\000\200\020\000\000\325\020\000\000\?"
  "\021\000\000\224\021\000\000\376\021\000\000S\022\000\000\275\022\000\000\022\023\000\000m\023\000\000\302\023\000"
  "\0001\024\000\000[\024\000\000\205\024\000\000\256\024\000\000\330\024\000\000\316\025\000\000\234\026\000\000E\027"
  "\000\000\264\027\000\000\020\030\000\000\225\030\000\000\361\030\000\000P\031\000\000\270\031\000\000\007\032\000\000"
  "\036\032\000\000q\032\000\000\310\032\000\000\347\032\000\000:\033\000\000\250\033\000\000\035\034\000\000\250\034"
  "\000\000\005\035\000\000\205\035\000\000\206\035\000\000\263\035\000\000\264\035\000\000\336\035\000\000\337\035\000"
  "\000\016\036\000\000\017\036\000\000;\036\000\000<\036\000\000d\036\000\000e\036\000\000\321\036\000\000#\037\000\000"
  "9\037\000\000;\037\000\000<\037\000\000F\037\000\000\016 \000\000p \000\000q \000\000r \000\000\n<html>\n\t<head>\n<m"
  "eta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t"
  "\n\t\t<script type=\"text/javascript\"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElement"
  "ById(\"useauth\"));\n\t\t\tchangeduseajax(document.getElementById(\"useAjax\"));\n\t\t\tchangedusestreamdev(document."
  "getElementById(\"useStreamdev\"));\n\t\t\tif (document.getElementById(\"message\").value != \"\")\n\t\t\t\talert(docu"
  "ment.getElementById(\"message\").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getEle"
  "mentById(\"authsection\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\tfunction setauthch"
  "anged(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"authchanged\").value = 1;\n\t\t}\n\t\tfunction changeduseaja"
  "x(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"ajaxsection\").style.display = (selection.checked \? \"block\" :"
  " \"none\");\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"streamdevsect"
  "ion\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body on"
  "load=\"initform(); adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form"
  " method=\"post\" action=\"setup.html\">\n\t\t\t\t<input type=\"hidden\" name=\"authchanged\" value=\"\" id=\"authchan"
  "ged\"/>\n\t\t\t\t<input type=\"hidden\" name=\"message\" value=\"\" id=\"message\"/>\n\t\t\t\t<table class=\"formular"
  "\" cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td  class=\"toprow leftcol right"
  "col\" colspan=\"2\"><div class=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t"
  "\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t"
  "\t\t\t\t\t<input type=\"checkbox\" name=\"useauth\" id=\"useauth\" value=\"1\" onclick=\"changeduseauth(this)\"/>\n\t"
  "\t\t\t\t\t\t<div id=\"authsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cel"
  "lspacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin"
  "\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"login\" value=\"\" id=\"login\" onchange=\"setauthch"
  "anged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"with"
  "margin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"password\" name=\"pass\" value=\"\" id=\"pass\" onchange=\""
  "setauthchanged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div cla"
  "ss=\"withmargin\"><a href=\"users.html\"></a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<"
  "tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"t"
  "ext\" name=\"localnetmask\" value=\"\" id=\"localnetmask\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t"
  "\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div cl"
  "ass=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"s"
  "howLogo\" id=\"showLogo\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="
  "\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input t"
  "ype=\"checkbox\" name=\"useAjax\" id=\"useAjax\" value=\"1\" onclick=\"changeduseajax(this)\"/>\n\t\t\t\t\t\t\t<div i"
  "d=\"ajaxsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" cla"
  "ss=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t"
  "\t\t\t\t\t\t\t<td><input type=\"checkbox\" name=\"showInfoBox\" id=\"showInfoBox\" value=\"1\" /></td>\n\t\t\t\t\t\t"
  "\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t"
  "\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t"
  "\t\t<input type=\"checkbox\" name=\"useStreamdev\" id=\"useStreamdev\" value=\"1\" onclick=\"changedusestreamdev(this"
  ")\"/>\n\t\t\t\t\t\t\t<div id=\"streamdevsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpad"
  "ding=\"0\" cellspacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class"
  "=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt0\" id=\"streamVideoOpt0"
  "\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div"
  " class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt1\" id=\"streamVide"
  "oOpt1\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\""
  "><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt2\" id=\"strea"
  "mVideoOpt2\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"la"
  "bel\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamVideoOpt3\" id=\""
  "streamVideoOpt3\" size=\"100\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class"
  "=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamdevport\" id"
  "=\"streamdevport\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><"
  "div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><select name=\"streamdevtype\" size=\"1\" id=\"streamdevty"
  "pe\">\n\t\t\t\t\t\t\t\t\t<option value=\"TS\" >TS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"PES\" >PES</option>\n\t"
  "\t\t\t\t\t\t\t\t<option value=\"PS\" >PS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"ES\" >ES</option>\n\t\t\t\t\t\t"
  "\t\t\t<option value=\"EXT\" >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table"
  ">\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n                                        <tr>\n          "
  "                                      <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n           "
  "                                     <td class=\"rightcol\">\n                                                       "
  " <input type=\"checkbox\" name=\"markNewRec\" id=\"markNewRec\" value=\"1\" />\n                                     "
  "           </td>\n                                        </tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftco"
  "l\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox"
  "\" name=\"showIMDb\" id=\"showIMDb\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t"
  "<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t"
  "\t<input type=\"checkbox\" name=\"showPlayMediaplayer\" id=\"showPlayMediaplayer\" value=\"1\" />\n\t\t\t\t\t\t</td>"
  "\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t"
  "\t\t\t\t\t<td class=\"rightcol\"><input type=\"number\" min=\"0\" name=\"lastchannel\" value=\"\" id=\"lastchannel\" "
  "/></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></"
  "td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"times\" value=\"\" id=\"times\" />\n\t\t\t\t\t\t"
  "\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></"
  "td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"channelGroups\" value=\"\" id=\"channelGroups\" /"
  ">\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmar"
  "gin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"number\" min=\"1\" max= \"23\" name=\"scheduleDu"
  "ration\" value=\"\" id=\"scheduleDuration\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td"
  " class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<"
  "input type=\"checkbox\" name=\"showChannelsWithoutEPG\" id=\"showChannelsWithoutEPG\" value=\"1\" />\n\t\t\t\t\t\t</t"
  "d>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>"
  "\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"startscreen\" size=\"1\" id=\"startscreen\">\n\t\t\t\t\t\t\t<opti"
  "on value=\"whatsonnow\" ></option>\n\t\t\t\t\t\t\t<option value=\"whatsonnext\" ></option>\n\t\t\t\t\t\t\t<option val"
  "ue=\"schedule\" ></option>\n\t\t\t\t\t\t\t<option value=\"multischedule\" ></option>\n\t\t\t\t\t\t\t<option value=\"r"
  "ecordings\" ></option>\n\t\t\t\t\t\t\t<option value=\"timers\" ></option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr"
  ">\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td cl"
  "ass=\"rightcol\"><select name=\"theme\" size=\"1\" id=\"theme\">\n\t\t\t\t\t\t\t<option value=\"\" ></option>\n\t\t\t"
  "\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottomrow"
  "\" colspan=\"2\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\" na"
  "me=\"save\" ></button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t"
  "\t</div>\n\t</body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string lastchannel = qparam.get< std::string >("lastchannel");
bool useauth = qparam.get< bool >("useauth", ( false));
std::string login = qparam.get< std::string >("login");
std::string pass = qparam.get< std::string >("pass");
std::string times = qparam.get< std::string >("times");
std::string channelGroups = qparam.get< std::string >("channelGroups");
std::string scheduleDuration = qparam.get< std::string >("scheduleDuration");
std::string startscreen = qparam.get< std::string >("startscreen");
std::string theme = qparam.get< std::string >("theme");
std::string localnetmask = qparam.get< std::string >("localnetmask");
std::string showLogo = qparam.get< std::string >("showLogo");
std::string useAjax = qparam.get< std::string >("useAjax");
std::string showInfoBox = qparam.get< std::string >("showInfoBox");
std::string useStreamdev = qparam.get< std::string >("useStreamdev");
std::string markNewRec = qparam.get< std::string >("markNewRec");
std::string showIMDb = qparam.get< std::string >("showIMDb");
std::string showPlayMediaplayer = qparam.get< std::string >("showPlayMediaplayer");
std::string showChannelsWithoutEPG = qparam.get< std::string >("showChannelsWithoutEPG");
std::string streamdevport = qparam.get< std::string >("streamdevport");
std::string streamdevtype = qparam.get< std::string >("streamdevtype");
std::string streamVideoOpt0 = qparam.get< std::string >("streamVideoOpt0");
std::string streamVideoOpt1 = qparam.get< std::string >("streamVideoOpt1");
std::string streamVideoOpt2 = qparam.get< std::string >("streamVideoOpt2");
std::string streamVideoOpt3 = qparam.get< std::string >("streamVideoOpt3");
int authchanged = qparam.get< int >("authchanged", ( 0));
  // </%args>

#line 39 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 42 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth() ) return reply.redirect("login.html");
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? "checked=\"checked\"" : "" );

	std::string message;

	if ( request.getMethod() == "POST") {
		if (authchanged && useauth && (login.empty() || pass.empty()))
			message = tr("Please set login and password!");
		else
		{
			LiveSetup().SetLastChannel(lastchannel != "" ? lexical_cast< int >(lastchannel):0);
			LiveSetup().SetUseAuth(useauth);
			if (useauth) {
				LiveSetup().SetAdminLogin(login);
				if (pass != "")
					LiveSetup().SetAdminPassword(pass);
				LiveSetup().SetLocalNetMask(localnetmask);
				LiveSetup().CheckLocalNet(request.getPeerIp());
			}
			LiveSetup().SetTimes(times);
			LiveSetup().SetChannelGroups(channelGroups);
			LiveSetup().SetScheduleDuration(scheduleDuration);
			LiveSetup().SetStartScreen(startscreen);
			LiveSetup().SetTheme(theme);
			LiveSetup().SetShowLogo(!showLogo.empty());
			LiveSetup().SetUseAjax(!useAjax.empty());
			if (LiveSetup().GetUseAjax()) {
				LiveSetup().SetShowInfoBox(!showInfoBox.empty());
			}
			LiveSetup().SetUseStreamdev(!useStreamdev.empty());
			LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : lexical_cast<int>(streamdevport));
			LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
			LiveSetup().SetMarkNewRec(!markNewRec.empty());

			std::string def = "ffmpeg -loglevel warning -f mpegts -analyzeduration 1.2M -probesize 5M "
				"-i <input> -map 0:v -map 0:a:0 -c:v copy -c:a aac -ac 2";
			LiveSetup().SetStreamVideoOpt0(streamVideoOpt0.empty() ? def : streamVideoOpt0);
			LiveSetup().SetStreamVideoOpt1(streamVideoOpt1.empty() ? def : streamVideoOpt1);
			LiveSetup().SetStreamVideoOpt2(streamVideoOpt2.empty() ? def : streamVideoOpt2);
			LiveSetup().SetStreamVideoOpt3(streamVideoOpt3.empty() ? def : streamVideoOpt3);

			LiveSetup().SetShowIMDb(!showIMDb.empty());
			LiveSetup().SetShowPlayMediaplayer(!showPlayMediaplayer.empty());
			LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
			LiveSetup().SaveSetup();

			message = tr("Setup saved.");
		}
	}
	pageTitle = tr("Setup");
	int ilastchannel = LiveSetup().GetLastChannel();
	if (ilastchannel == std::numeric_limits< int >::max())
		lastchannel = "";
	else
		lastchannel = lexical_cast<std::string, int>(ilastchannel);

	login = LiveSetup().GetAdminLogin();
	useauth = LiveSetup().GetUseAuth();
	times = LiveSetup().GetTimes();
	channelGroups = LiveSetup().GetChannelGroups();
	scheduleDuration = LiveSetup().GetScheduleDuration();
	startscreen = LiveSetup().GetStartScreen();
	theme = LiveSetup().GetTheme();
	localnetmask = LiveSetup().GetLocalNetMask();
	showLogo = LiveSetup().GetShowLogo() ? "1" : "";
	useAjax = LiveSetup().GetUseAjax() ? "1" : "";
	showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
	useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
	streamdevport = lexical_cast<std::string, int>(LiveSetup().GetStreamdevPort());
	streamdevtype = LiveSetup().GetStreamdevType();
	markNewRec = LiveSetup().GetMarkNewRec() ? "1" : "";
	streamVideoOpt0 = LiveSetup().GetStreamVideoOpt0();
	streamVideoOpt1 = LiveSetup().GetStreamVideoOpt1();
	streamVideoOpt2 = LiveSetup().GetStreamVideoOpt2();
	streamVideoOpt3 = LiveSetup().GetStreamVideoOpt3();
	showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
	showPlayMediaplayer = LiveSetup().GetShowPlayMediaplayer() ? "1" : "";
	showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 126 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 126 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 130 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 131 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 131 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 132 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 132 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById("useauth"));\n\t\t\tchangeduseajax(document.getElementById("useAjax"));\n\t\t\tchangedusestreamdev(document.getElementById("useStreamdev"));\n\t\t\tif (document.getElementById("message").value != "")\n\t\t\t\talert(document.getElementById("message").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById("authchanged").value = 1;\n\t\t}\n\t\tfunction changeduseajax(selection)\n\t\t{\n\t\t\tdocument.getElementById("ajaxsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById("streamdevsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="initform(); adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 161 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 161 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 162 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 162 "setup.ecpp"
    _tnt_cq4.add( "active", ("setup"));
#line 162 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n\t\t\t<form method="post" action="setup.html">\n\t\t\t\t<input type="hidden" name="authchanged" value="
#line 165 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << _tntChunks[6]; // " id="authchanged"/>\n\t\t\t\t<input type="hidden" name="message" value="
#line 166 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[7]; // " id="message"/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 169 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << _tntChunks[8]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 172 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << _tntChunks[9]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useauth" id="useauth" value="1" 
#line 174 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << _tntChunks[10]; // onclick="changeduseauth(this)"/>\n\t\t\t\t\t\t\t<div id="authsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 178 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << _tntChunks[11]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="login" value="
#line 179 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << _tntChunks[12]; // " id="login" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 182 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << _tntChunks[13]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="password" name="pass" value="
#line 183 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << _tntChunks[14]; // " id="pass" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin"><a href="users.html">
#line 186 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << _tntChunks[15]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 190 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << _tntChunks[16]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="text" name="localnetmask" value="
#line 191 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << _tntChunks[17]; // " id="localnetmask" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 198 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << _tntChunks[18]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showLogo" id="showLogo" value="1" 
#line 200 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << _tntChunks[19]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 204 "setup.ecpp"
  reply.sout() << ( tr("Use ajax technology") );
  reply.out() << _tntChunks[20]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useAjax" id="useAjax" value="1" 
#line 206 "setup.ecpp"
 CHECKIF(!useAjax.empty()); 
  reply.out() << _tntChunks[21]; // onclick="changeduseajax(this)"/>\n\t\t\t\t\t\t\t<div id="ajaxsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 210 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << _tntChunks[22]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="checkbox" name="showInfoBox" id="showInfoBox" value="1" 
#line 211 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << _tntChunks[23]; // /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 218 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << _tntChunks[24]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useStreamdev" id="useStreamdev" value="1" 
#line 220 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << _tntChunks[25]; // onclick="changedusestreamdev(this)"/>\n\t\t\t\t\t\t\t<div id="streamdevsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 224 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming h264") );
  reply.out() << _tntChunks[26]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt0" id="streamVideoOpt0" size="100" value="
#line 225 "setup.ecpp"
  reply.sout() << ( streamVideoOpt0 );
  reply.out() << _tntChunks[27]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 228 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming HEVC") );
  reply.out() << _tntChunks[28]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt1" id="streamVideoOpt1" size="100" value="
#line 229 "setup.ecpp"
  reply.sout() << ( streamVideoOpt1 );
  reply.out() << _tntChunks[29]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 232 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming MPEG2") );
  reply.out() << _tntChunks[30]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt2" id="streamVideoOpt2" size="100" value="
#line 233 "setup.ecpp"
  reply.sout() << ( streamVideoOpt2 );
  reply.out() << _tntChunks[31]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 236 "setup.ecpp"
  reply.sout() << ( tr("Web-Streaming others") );
  reply.out() << _tntChunks[32]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamVideoOpt3" id="streamVideoOpt3" size="100" value="
#line 237 "setup.ecpp"
  reply.sout() << ( streamVideoOpt3 );
  reply.out() << _tntChunks[33]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 240 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << _tntChunks[34]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamdevport" id="streamdevport" value="
#line 241 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << _tntChunks[35]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 244 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << _tntChunks[36]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><select name="streamdevtype" size="1" id="streamdevtype">\n\t\t\t\t\t\t\t\t\t<option value="TS" 
#line 246 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << _tntChunks[37]; // >TS</option>\n\t\t\t\t\t\t\t\t\t<option value="PES" 
#line 247 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << _tntChunks[38]; // >PES</option>\n\t\t\t\t\t\t\t\t\t<option value="PS" 
#line 248 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << _tntChunks[39]; // >PS</option>\n\t\t\t\t\t\t\t\t\t<option value="ES" 
#line 249 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << _tntChunks[40]; // >ES</option>\n\t\t\t\t\t\t\t\t\t<option value="EXT" 
#line 250 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << _tntChunks[41]; // >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n                                        <tr>\n                                                <td class="label leftcol"><div class="withmargin">
#line 258 "setup.ecpp"
  reply.sout() << ( tr("Mark new recordings") );
  reply.out() << _tntChunks[42]; // :</div></td>\n                                                <td class="rightcol">\n                                                        <input type="checkbox" name="markNewRec" id="markNewRec" value="1" 
#line 260 "setup.ecpp"
 CHECKIF(!markNewRec.empty()); 
  reply.out() << _tntChunks[43]; // />\n                                                </td>\n                                        </tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 264 "setup.ecpp"
  reply.sout() << ( tr("Show link to IMDb in list views") );
  reply.out() << _tntChunks[44]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showIMDb" id="showIMDb" value="1" 
#line 266 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << _tntChunks[45]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 270 "setup.ecpp"
  reply.sout() << ( tr("Show \"Play in Mediaplayer\" in list views") );
  reply.out() << _tntChunks[46]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showPlayMediaplayer" id="showPlayMediaplayer" value="1" 
#line 272 "setup.ecpp"
 CHECKIF(!showPlayMediaplayer.empty()); 
  reply.out() << _tntChunks[47]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 276 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << _tntChunks[48]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="number" min="0" name="lastchannel" value="
#line 277 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << _tntChunks[49]; // " id="lastchannel" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 280 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << _tntChunks[50]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="times" value="
#line 281 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << _tntChunks[51]; // " id="times" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 282 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 282 "setup.ecpp"
    _tnt_cq5.add( "text", (tr("Format is HH:MM. Separate multiple times with a semicolon")));
#line 282 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[52]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 285 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << _tntChunks[53]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="channelGroups" value="
#line 286 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << _tntChunks[54]; // " id="channelGroups" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 287 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 287 "setup.ecpp"
    _tnt_cq6.add( "text", (tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")));
#line 287 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[55]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 290 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << _tntChunks[56]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="number" min="1" max= "23" name="scheduleDuration" value="
#line 291 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << _tntChunks[57]; // " id="scheduleDuration" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 295 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << _tntChunks[58]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1" 
#line 297 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << _tntChunks[59]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 302 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << _tntChunks[60]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n\t\t\t\t\t\t\t<option value="whatsonnow" 
#line 304 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << _tntChunks[61]; // >
#line 304 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << _tntChunks[62]; // </option>\n\t\t\t\t\t\t\t<option value="whatsonnext" 
#line 305 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << _tntChunks[63]; // >
#line 305 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << _tntChunks[64]; // </option>\n\t\t\t\t\t\t\t<option value="schedule" 
#line 306 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << _tntChunks[65]; // >
#line 306 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << _tntChunks[66]; // </option>\n\t\t\t\t\t\t\t<option value="multischedule" 
#line 307 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << _tntChunks[67]; // >
#line 307 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << _tntChunks[68]; // </option>\n\t\t\t\t\t\t\t<option value="recordings" 
#line 308 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << _tntChunks[69]; // >
#line 308 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << _tntChunks[70]; // </option>\n\t\t\t\t\t\t\t<option value="timers" 
#line 309 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << _tntChunks[71]; // >
#line 309 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << _tntChunks[72]; // </option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 313 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << _tntChunks[73]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 315 "setup.ecpp"

{
	const std::string dirPath(Plugin::GetResourceDirectory() + "/themes");
	cReadDir d(dirPath.c_str());
	struct dirent* e;
	std::string parent("..");
	std::string current(".");
	std::string cvsDir("CVS");
	while ((e = d.Next())) {
		if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
			continue;
		}
		/* Check if entry is a directory: I do not rely on e->d_type
		   here because on some systems it is allways DT_UNKNOWN. Also
		   testing for DT_DIR does not take into account symbolic
		   links to directories.
		*/
		struct stat buf;
		if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
			continue;
		}

  reply.out() << _tntChunks[74]; // \t\t\t\t\t\t\t<option value="
#line 337 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[75]; // " 
#line 337 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << _tntChunks[76]; // >
#line 337 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[77]; // </option>\n
#line 338 "setup.ecpp"

	}
}

  reply.out() << _tntChunks[78]; // \t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit" name="save" >
#line 347 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[79]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[80]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[81]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
