////////////////////////////////////////////////////////////////////////
// stream.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.stream")

// <%pre>
#line 1 "stream.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <ffmpeg.h>
#include <tools.h>
#include <epg_events.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("stream");

static const char* rawData = "\214\000\000\000\t\001\000\000\024\001\000\000\027\001\000\000\250\001\000\000\253\001"
  "\000\000\276\002\000\000\306\002\000\000\006\004\000\000O\004\000\000\272\004\000\000\343\004\000\000h\005\000\000u"
  "\005\000\000|\005\000\000}\005\000\000\231\005\000\000\272\005\000\000\306\005\000\000\341\005\000\000\351\005\000"
  "\000\204\006\000\000\206\006\000\000\207\006\000\000\300\006\000\000\332\006\000\000\333\006\000\000\334\006\000\0005"
  "\007\000\000O\007\000\000c\007\000\000h\007\000\000\263\007\000\000\371\007\000\000\007\010\000\000\n<!DOCTYPE html>"
  "\n<html>\n\t<head>\n\t\t<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR Li"
  "ve - </title>\n\t\t\n\t\t\n\t\t<script> window.onbeforeunload = function() { player.stop(); } </script>\n\t</head>\n"
  "\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n            <"
  "center>\n\t\t\t<div id=\"player\">\n\n\t\t\t\t<script src=\"https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.mi"
  "n.js\"></script>\n\t\t\t\t<script>\n\t\t\t\tClappr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n\t\t\t\tvar player = new Cla"
  "ppr.Player({\n\t\t\t\t\tsource: \"media//master_.m3u8\",\n\t\t\t\t\tparentId: \"#player\",\n\t\t\t\t\twidth: 1280, he"
  "ight: 720,\n\t\t\t\t\tautoPlay: \"true\",\n\t\t\t\t\tevents: {\n\t\t\t\t\t\tonError: function(error) { console.log('C"
  "alppr.Player error: ', error); player.play(); },\n\t\t\t\t\t\tonEnded: function() { console.log('Clappr.Player ended'"
  "); player.play(); },\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t\t</script>\n\t\t\t</div>\n\t\t\t<table class=\"listing\" cells"
  "pacing=\"0\" cellpadding=\"0\">\n\t\t\t\t<tr>\n\t\t\t\t\t\n\t\t\t\t\t<td class=\"topaligned bottomrow\">\n\t\t\t\t\t"
  "\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<div class=\"nomargin nowrap\"></div>\n\t\t\t\t\t\t\t<div class=\"progres"
  "s\"><div></div></div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\"topaligned bottomrow\" style=\"widt"
  "h: 788px\">\n\t\t\t\t\t\t<div class=\"more withmargin\">\n\t\t\t\t\t\t    <a\n\t\t\t\t\t\t\t\n\t\t\t\t\t\t\t><span cl"
  "ass=\"title\"></span><br /><span class=\"short\"></span></a>\n\t\t\t\t\t\t\t<span class=\"title\"></span>\n\t\t\t\t\t"
  "\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\"topaligned rightcol bottomrow\" style=\"width: 250px\"><div class=\""
  "station withmargin\"><a\thref=\"schedule.html\?channel=\" ></a></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t</table>"
  "\n\t\t\t</center>\n\t\t</div>\n\t</body>\n</html>\n\n\n<form action=\"stream.html\" method=\"get\" id=\"channels\">\n"
  "  <span>\n    <label for=\"channel\">:&nbsp;<span class=\"bold\"></span></label>\n    \n    \n  </span>\n</form>\n<sp"
  "an class=\"sep\">|</span>\n<a href=\"stream.html\?channel=\">\302\253 Prev</a>\n<span class=\"sep\">|</span>\n<a href"
  "=\"stream.html\?channel=\">Next \302\273</a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string channelid_str = qparam.get< std::string >("channelid_str");
int channel = qparam.get< int >("channel", ( 1));
  // </%args>

#line 17 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 18 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( NULL));   // <%session> FFmpegThread * f_worker( NULL)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 21 "stream.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 24 "stream.ecpp"

        tChannelID channelid;
        channelid = channelid.FromString(channelid_str.c_str());
	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Stream");

	// check for session cookie.
	std::string session;
	if (request.hasCookie("tntnet")) {
		session = request.getCookie("tntnet");
		dsyslog("vdrlive::stream::session(%s)", session.c_str());
	}
	else {
		esyslog("vdrlive::stream: no session cookie found");
		return reply.redirect("");
	}

#if VDRVERSNUM < 20301
	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );
#endif

	if ( qparam.has("channelid_str") ) {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		cChannel *c = (cChannel *)Channels->GetByChannelID( channelid );
#else
		cChannel *c = Channels.GetByChannelID( channelid );
#endif
		if ( c ) channel = c->Number();
	}
	if ( channel > 0 ) {
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		Channel = (cChannel *)Channels->GetByNumber( channel );
#else
		Channel = Channels.GetByNumber( channel );
#endif
	}
	if ( Channel == 0 )
		throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );

	dsyslog("vdrlive::stream::vtype(%d)", Channel->Vtype());
	dsyslog("vdrlive::stream::f_worker(%p)", f_worker);
	if ( !f_worker) {
		f_worker = new FFmpegThread();
		dsyslog("vdrlive::stream: new FFmpegThread created");
	}

	switch( Channel->Vtype() ) {
		case 27: // h264
			f_worker->StartFFmpeg(session, channel, 0);
			break;
		case 36: // h265
			f_worker->StartFFmpeg(session, channel, 1);
			break;
		case 2: // mpeg2
			f_worker->StartFFmpeg(session, channel, 2);
			break;
		default: // others
			f_worker->StartFFmpeg(session, channel, 3);
	}
	dsyslog("vdrlive::stream::StartFFmpeg(%d)", channel);


  reply.out() << _tntChunks[0]; // \n<!DOCTYPE html>\n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR Live - 
#line 96 "stream.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 97 "stream.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 97 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 98 "stream.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 98 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t<script> window.onbeforeunload = function() { player.stop(); } </script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 102 "stream.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 102 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 103 "stream.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 103 "stream.ecpp"
    _tnt_cq3.add( "active", ("stream"));
#line 103 "stream.ecpp"
    _tnt_cq3.add( "component", ("stream.channel_selection"));
#line 103 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n            <center>\n\t\t\t<div id="player">\n\n\t\t\t\t<script src="https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js"></script>\n\t\t\t\t<script>\n\t\t\t\tClappr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n\t\t\t\tvar player = new Clappr.Player({\n\t\t\t\t\tsource: "media/
#line 112 "stream.ecpp"
  reply.sout() << ( session );
  reply.out() << _tntChunks[6]; // /master_
#line 112 "stream.ecpp"
  reply.sout() << ( std::to_string(channel) );
  reply.out() << _tntChunks[7]; // .m3u8",\n\t\t\t\t\tparentId: "#player",\n\t\t\t\t\twidth: 1280, height: 720,\n\t\t\t\t\tautoPlay: "true",\n\t\t\t\t\tevents: {\n\t\t\t\t\t\tonError: function(error) { console.log('Calppr.Player error: ', error); player.play(); },\n\t\t\t\t\t\tonEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t\t</script>\n\t\t\t</div>\n
#line 123 "stream.ecpp"

dsyslog("vdrlive::stream: generating EPG info");
const cSchedule *Schedule = NULL;
{
#if VDRVERSNUM >= 20301

	LOCK_SCHEDULES_READ;
#else
	cSchedulesLock schedulesLock;
	const cSchedules* Schedules = cSchedules::Schedules(schedulesLock);
#endif

	Schedule = Schedules->GetSchedule(Channel);
}
const cEvent *Event = NULL;
if (Schedule)
	Event = Schedule->GetPresentEvent();

EpgInfoPtr epgEvent;
if (Event) {
	epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);

	tChannelID chanId;
	tEventID eventId;
	EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);
	char const * timeFormat = tr("%I:%M %p");
	char const * dateFormat = tr("%A, %x");
	std::string headTime = FormatDateTime(timeFormat, time(0));
	std::string headDate = FormatDateTime(dateFormat, time(0));
	std::string startTime(epgEvent->StartTime(tr("%I:%M %p")));
	std::string endTime(epgEvent->EndTime(tr("%I:%M %p")));
	std::string startDate(epgEvent->StartTime(tr("%a, %x")));

	std::string timeSpan(startTime + " - " + endTime);

	if (startTime.empty() && endTime.empty()) {
		timeSpan = headTime;
		startDate = headDate;
	}
  std::string longDescription = StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars()))
	  + "<br/><br/>" + tr("Click to view details.");
	
  reply.out() << _tntChunks[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr>\n\t\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 167 "stream.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 167 "stream.ecpp"
    _tnt_cq4.add( "detail", (0));
#line 167 "stream.ecpp"
    _tnt_cq4.add( "endTime", (epgEvent->GetEndTime()));
#line 167 "stream.ecpp"
    _tnt_cq4.add( "epgid", (epgEvent->Id()));
#line 167 "stream.ecpp"
    _tnt_cq4.add( "lastCurrentChanel", (1));
#line 167 "stream.ecpp"
    _tnt_cq4.add( "startTime", (epgEvent->GetStartTime()));
#line 167 "stream.ecpp"
    _tnt_cq4.add( "title", (epgEvent->Title()));
#line 167 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[9]; // \n\t\t\t\t\t<td class="topaligned bottomrow">\n\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<div class="nomargin nowrap">
#line 170 "stream.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[10]; // </div>\n\t\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 171 "stream.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 171 "stream.ecpp"
    _tnt_cq5.add( "duration", (epgEvent->Duration()));
#line 171 "stream.ecpp"
    _tnt_cq5.add( "progress", (epgEvent->Elapsed()));
#line 171 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // </div></div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="topaligned bottomrow" style="width: 788px">\n\t\t\t\t\t\t<div class="more withmargin">\n
#line 176 "stream.ecpp"
						if (eventId != 0) {

  reply.out() << _tntChunks[12]; // \t\t\t\t\t\t    <a\n
#line 178 "stream.ecpp"
							if (!longDescription.empty()) {

  reply.out() << _tntChunks[13]; // \t\t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 179 "stream.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 179 "stream.ecpp"
    _tnt_cq6.add( "text", (longDescription));
#line 179 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 179 "stream.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 179 "stream.ecpp"
    _tnt_cq7.add( "domId", (epgEvent->Id()));
#line 179 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[14]; // \n
#line 180 "stream.ecpp"
							}

  reply.out() << _tntChunks[15]; // \t\t\t\t\t\t\t><span class="title">
#line 181 "stream.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[16]; // </span><br /><span class="short">
#line 181 "stream.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[17]; // </span></a>\n
#line 182 "stream.ecpp"
							} else {

  reply.out() << _tntChunks[18]; // \t\t\t\t\t\t\t<span class="title">
#line 183 "stream.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[19]; // </span>\n
#line 184 "stream.ecpp"
							}

  reply.out() << _tntChunks[20]; // \t\t\t\t\t\t</div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="topaligned rightcol bottomrow" style="width: 250px"><div class="station withmargin"><a\thref="schedule.html\?channel=
#line 187 "stream.ecpp"
  reply.sout() << ( std::to_string(channel) );
  reply.out() << _tntChunks[21]; // " 
  // <& tooltip.hint ...
  { 
#line 187 "stream.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 187 "stream.ecpp"
    _tnt_cq8.add( "text", (tr("View the schedule of this channel")));
#line 187 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[22]; // >
#line 187 "stream.ecpp"
  reply.sout() << ( std::to_string(channel) );
#line 187 "stream.ecpp"
  reply.sout() << ( tr(" - ") );
#line 187 "stream.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[23]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t\t</center>\n
#line 192 "stream.ecpp"
} // if (Event)

  reply.out() << _tntChunks[24]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[25]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[26]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 17 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 18 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( NULL));   // <%session> FFmpegThread * f_worker( NULL)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 21 "stream.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_SHARED_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[27]; // <form action="stream.html" method="get" id="channels">\n  <span>\n    <label for="channel">
#line 201 "stream.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[28]; // :&nbsp;<span class="bold">
#line 201 "stream.ecpp"
  reply.sout() << ( std::to_string(Channel->Number()) );
  reply.out() << _tntChunks[29]; // </span></label>\n    
  // <& channels_widget ...
  { 
#line 202 "stream.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 202 "stream.ecpp"
    _tnt_cq9.add( "name", ("channel"));
#line 202 "stream.ecpp"
    _tnt_cq9.add( "onchange", ("player.stop(); document.forms.channels.submit()"));
#line 202 "stream.ecpp"
    _tnt_cq9.add( "selected", (Channel ? *Channel->GetChannelID().ToString() : ""));
#line 202 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n    
  // <& pageelems.ajax_action_href ...
  { 
#line 203 "stream.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 203 "stream.ecpp"
    _tnt_cq10.add( "action", "switch_channel");
#line 203 "stream.ecpp"
    _tnt_cq10.add( "alt", "");
#line 203 "stream.ecpp"
    _tnt_cq10.add( "image", "zap.png");
#line 203 "stream.ecpp"
    _tnt_cq10.add( "param", (Channel->GetChannelID()));
#line 203 "stream.ecpp"
    _tnt_cq10.add( "tip", (tr("Switch to this channel.")));
#line 203 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[31]; // \n  </span>\n</form>\n<span class="sep">|</span>\n<a href="stream.html\?channel=
#line 207 "stream.ecpp"
  reply.sout() << ( std::max(0, ((int)Channel->Number() - 1)) );
  reply.out() << _tntChunks[32]; // ">\302\253 Prev</a>\n<span class="sep">|</span>\n<a href="stream.html\?channel=
#line 209 "stream.ecpp"
  reply.sout() << ( (Channel->Number() + 1) );
  reply.out() << _tntChunks[33]; // ">Next \302\273</a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
